package com.sun.corba.se.impl.orb;

import java.util.Iterator;
import java.lang.reflect.Array;
import com.sun.corba.se.spi.orb.StringPair;
import java.util.LinkedList;
import java.util.Properties;
import com.sun.corba.se.spi.orb.Operation;
import com.sun.corba.se.impl.logging.ORBUtilSystemException;

public class PrefixParserAction extends ParserActionBase
{
    private Class componentType;
    private ORBUtilSystemException wrapper;
    
    public PrefixParserAction(String s, Operation operation, String s2, Class componentType) {
        super(s, true, operation, s2);
        this.componentType = componentType;
        this.wrapper = ORBUtilSystemException.get("orb.lifecycle");
    }
    
    @Override
    public Object apply(Properties properties) {
        String s = this.getPropertyName();
        int length = s.length();
        if (s.charAt(length - 1) != '.') {
            s += '.';
            ++length;
        }
        LinkedList o = new LinkedList();
        Iterator<Object> iterator = properties.keySet().iterator();
        while (iterator.hasNext()) {
            String key = (String)(String)iterator.next();
            if (key.startsWith(s)) {
                o.add(this.getOperation().operate(new StringPair(key.substring(length), properties.getProperty(key))));
            }
            else {
                continue;
            }
        }
        int size = o.size();
        if (size > 0) {
            Object instance;
            try {
                instance = Array.newInstance(this.componentType, size);
            }
            catch (Throwable t) {
                throw this.wrapper.couldNotCreateArray(t, this.getPropertyName(), this.componentType, new Integer(size));
            }
            Iterator<Object> iterator2 = o.iterator();
            for (int value = 0; iterator2.hasNext(); ++value) {
                Object next = iterator2.next();
                try {
                    Array.set(instance, value, next);
                }
                catch (Throwable t2) {
                    throw this.wrapper.couldNotSetArray(t2, this.getPropertyName(), new Integer(value), this.componentType, new Integer(size), next.toString());
                }
            }
            return instance;
        }
        return null;
    }
}
